# coding: utf-8

"""
    Yagna Payment API

     Invoicing and Payments is a fundamental area of Yagna Ecosystem functionality. It includes aspects of communication between Requestor, Provider and a selected Payment Platform, which becomes crucial when Activities are executed in the context of negotiated Agreements. Yagna applications must be able to exercise various payment models, and the Invoicing/Payment-related communication is happening in parallel to Activity control communication. To define functional patterns of Requestor/Provider interaction in this area, Payment API is specified.  An important principle of the Yagna Payment API is that the actual payment transactions are hidden behind the Invoice flow. In other words, a Yagna Application on Requestor side isn’t expected to trigger actual payment transactions. Instead it is expected to receive and accept Invoices raised by the Provider - based on Application’s Invoice Accept notifications, the Payment API implementation orchestrates the payment via a configured Payment platform.  **NOTE: This specification is work-in-progress.**   # noqa: E501

    The version of the OpenAPI document: 1.2.0
    Generated by: https://openapi-generator.tech
"""


import unittest

import ya_payment
from ya_payment.api.requestor_api import RequestorApi  # noqa: E501
from ya_payment.rest import ApiException


class TestRequestorApi(unittest.TestCase):
    """RequestorApi unit test stubs"""

    def setUp(self):
        self.api = ya_payment.api.requestor_api.RequestorApi()  # noqa: E501

    def tearDown(self):
        pass

    def test_accept_debit_note(self):
        """Test case for accept_debit_note

        Accept received Debit Note.  # noqa: E501
        """
        pass

    def test_accept_invoice(self):
        """Test case for accept_invoice

        Accept received Invoice.  # noqa: E501
        """
        pass

    def test_amend_allocation(self):
        """Test case for amend_allocation

        Amend Allocation.  # noqa: E501
        """
        pass

    def test_create_allocation(self):
        """Test case for create_allocation

        Create Allocation.  # noqa: E501
        """
        pass

    def test_get_allocation(self):
        """Test case for get_allocation

        Get Allocation.  # noqa: E501
        """
        pass

    def test_get_allocations(self):
        """Test case for get_allocations

        Get Allocations.  # noqa: E501
        """
        pass

    def test_get_outgoing_payment(self):
        """Test case for get_outgoing_payment

        Get outgoing Payment.  # noqa: E501
        """
        pass

    def test_get_outgoing_payments(self):
        """Test case for get_outgoing_payments

        Get outgoing Payments.  # noqa: E501
        """
        pass

    def test_get_payments_for_received_debit_note(self):
        """Test case for get_payments_for_received_debit_note

        Get Payments for Debit Note.  # noqa: E501
        """
        pass

    def test_get_payments_for_received_invoice(self):
        """Test case for get_payments_for_received_invoice

        Get Payments for received Invoice.  # noqa: E501
        """
        pass

    def test_get_received_debit_note(self):
        """Test case for get_received_debit_note

        Get Debit Note.  # noqa: E501
        """
        pass

    def test_get_received_debit_notes(self):
        """Test case for get_received_debit_notes

        Get Debit Notes received by this Requestor.  # noqa: E501
        """
        pass

    def test_get_received_invoice(self):
        """Test case for get_received_invoice

        Get Invoice.  # noqa: E501
        """
        pass

    def test_get_received_invoices(self):
        """Test case for get_received_invoices

        Get Invoices received by this Requestor.  # noqa: E501
        """
        pass

    def test_get_requestor_debit_note_events(self):
        """Test case for get_requestor_debit_note_events

        Get Debit Note events.  # noqa: E501
        """
        pass

    def test_get_requestor_invoice_events(self):
        """Test case for get_requestor_invoice_events

        Get Invoice events.  # noqa: E501
        """
        pass

    def test_get_send_accounts(self):
        """Test case for get_send_accounts

        Get available accounts for sending payments.  # noqa: E501
        """
        pass

    def test_reject_debit_note(self):
        """Test case for reject_debit_note

        Reject received Debit Note.  # noqa: E501
        """
        pass

    def test_reject_invoice(self):
        """Test case for reject_invoice

        Reject received Invoice.  # noqa: E501
        """
        pass

    def test_release_allocation(self):
        """Test case for release_allocation

        Release Allocation.  # noqa: E501
        """
        pass


if __name__ == "__main__":
    unittest.main()
